﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TechNote33_FileCopy_CS
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private FileCopyCoreEx m_cFileCopyCore;

        private void Form1_Load(object sender, EventArgs e)
        {
            // 현재 Form을 MainForm으로 설정합니다.
            smartForm1.MainForm = this;

            m_cFileCopyCore = new FileCopyCoreEx();
            // Source 경로의 파일을 dest 경로로 복사하되 FileOverWrite의 속성값이 True인 경우
            // 동일 이름의 파일을 덮어쓰기. False인 경우 덮어쓰기 하지 않기
            m_cFileCopyCore.FileOverWrite = false;
        }

        // 프로그램 종료
        private void btnClose_Click(object sender, EventArgs e)
        {
            smartForm1.Close();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            // 원본 경로
            string strSrcFile = "Flash Disk\\Src\\";

            // 목적지(파일이 복사된) 경로
            string strDestFile = "하드 디스크\\Test\\Dest\\";

            // FailList 초기화
            lstCopyFailList.ClearAll();

            // 전체 파일 String 배열(Array) 선언
            string[] strAllFileList = new string[5];

            string[] strCopyFailList;

            // out 매개변수로 사용되어 선언만하고 초기화 필요없음
            int iSuccessCnt;

            // 복사할 원본 파일들을 배열(Array)에 순차적으로 저장
            strAllFileList[0] = "test.txt";
            strAllFileList[1] = "test.cs";
            strAllFileList[2] = "test.png";
            strAllFileList[3] = "test.exe";
            strAllFileList[4] = "test.docx";

            // 인자로는 SrcFile : 원본 경로, DestFile : 목적지 경로, filelist : 파일 리스트, iRetryCnt : 파일 복사 재시도 횟수, iSuccessCnt : 복사 성공카운트
            // iSuccessCnt는 메서드 내부에서 변경된 값을 참조하기위해 out파라미터로 선언
            strCopyFailList = m_cFileCopyCore.FileCopyRetry(strSrcFile, strDestFile, strAllFileList, Convert.ToInt32(udRetryCount.Value), out iSuccessCnt);
            
            // 파일 복사시 복사가 실패한 리스트가 있으면
            if (strCopyFailList != null)
            {
                // 실패한 리스트를 리스트박에서 추가
                foreach (string value in strCopyFailList)
                {
                    lstCopyFailList.AddItem(value);
                }
            }

            // 파일의 총 개수
            labFileCount.Text = strAllFileList.Length.ToString();
            // 복사 성공 횟수
            labSuccessCount.Text = iSuccessCnt.ToString();
            // 복사 실패 횟수
            labFailCount.Text = (strAllFileList.Length - iSuccessCnt).ToString();
        }
    }
}